Name:           maven-hpi-plugin
Version:        1.112
Release:        1%{?dist}
Summary:        Maven plugin to build Jenkins plugins

# Project is licensed under ASL 2.0, but following
# files are licensed under MIT:
# src/main/java/hudson/Extension.java
# src/main/java/jenkins/YesNoMaybe.java
License:        ASL 2.0 and MIT
URL:            https://github.com/jenkinsci/maven-hpi-plugin
Source0:        https://github.com/jenkinsci/%{name}/archive/%{name}-%{version}.tar.gz
# Stapler/Jenkins guys don't want to add whole ASL 2.0 license
# text to the repository. Their opinion is that having short ASL 2.0 notice
# in affected files is enough
Source1:        http://www.apache.org/licenses/LICENSE-2.0.txt
# MIT license text copied from MIT licesed file (see comment for license tag)
Source2:        LICENSE-MIT.txt

# Port to newer version of maven-archiver
# TODO possibly upstreamable (need testing)
Patch0:         0001-Update-maven-archiver-to-2.5.patch
# Bundled class from org.jenkins-ci:version-number
Patch1:         0001-Unbundle-org.jenkins-ci-version-number.patch
Patch2:         correctly-identify-core-plugins.patch

BuildArch:      noarch

BuildRequires:  maven-local
BuildRequires:  mvn(com.ibm.icu:icu4j)
BuildRequires:  mvn(com.sun.codemodel:codemodel)
BuildRequires:  mvn(jakarta-regexp:jakarta-regexp)
BuildRequires:  mvn(net.java.sezpoz:sezpoz)
BuildRequires:  mvn(org.apache.ant:ant-apache-regexp)
BuildRequires:  mvn(org.apache.maven:maven-archiver)
BuildRequires:  mvn(org.apache.maven:maven-artifact)
BuildRequires:  mvn(org.apache.maven:maven-plugin-api)
BuildRequires:  mvn(org.apache.maven:maven-project)
BuildRequires:  mvn(org.apache.maven.plugins:maven-antrun-plugin)
BuildRequires:  mvn(org.apache.maven.plugins:maven-archetype-plugin)
BuildRequires:  mvn(org.apache.maven.plugins:maven-dependency-plugin)
BuildRequires:  mvn(org.apache.maven.plugins:maven-plugin-plugin)
BuildRequires:  mvn(org.apache.maven.plugins:maven-release-plugin)
BuildRequires:  mvn(org.apache.maven.plugin-tools:maven-plugin-annotations)
BuildRequires:  mvn(org.codehaus.plexus:plexus-interactivity-api)
BuildRequires:  mvn(org.codehaus.plexus:plexus-utils)
BuildRequires:  mvn(org.jenkins-ci:version-number)
BuildRequires:  mvn(org.kohsuke.stapler:stapler-groovy)


%description
This package contains Apache Maven plugin for developing
plugins for Jenkins.

%package        javadoc
Summary:        Javadoc for %{name}

%description    javadoc
This package contains the API documentation for %{name}.


%prep
%setup -q -n %{name}-%{name}-%{version}

cp %{SOURCE1} LICENSE-ASL
cp %{SOURCE2} LICENSE-MIT

%patch0 -p1 -F2

# Replace bundled class from org.jenkins-ci:version-number with proper dependency
rm ./src/main/java/org/jenkinsci/maven/plugins/hpi/VersionNumber.java
%pom_add_dep org.jenkins-ci:version-number
%patch1 -p1 -F2

%patch2 -p1

# Fix groupId for ant-apache-regexp
%pom_xpath_replace "pom:dependency[pom:artifactId[text()='ant-apache-regexp']]/pom:groupId" \
    "<groupId>org.apache.ant</groupId>"

# Nothing really interesting in parent
%pom_remove_parent

# missing extension
%pom_xpath_remove "pom:extensions/pom:extension[pom:artifactId[text()='wagon-ssh']]"

# Remove "run" mojo, it requires jetty 6
rm src/main/java/org/jenkinsci/maven/plugins/hpi/ServletApiOnlyClassLoader.java
rm src/main/java/org/jenkinsci/maven/plugins/hpi/AbstractJetty6Mojo.java
rm src/main/java/org/jenkinsci/maven/plugins/hpi/AbstractJettyMojo.java
rm src/main/java/org/jenkinsci/maven/plugins/hpi/RunMojo.java
rm src/main/java/org/jenkinsci/maven/plugins/hpi/ConsoleScanner.java
# WarMojo depends on RunMojo
rm src/main/java/org/jenkinsci/maven/plugins/hpi/WarMojo.java

%pom_remove_dep :maven-jetty-plugin
%pom_remove_dep :maven-stapler-plugin

# Remove "create" mojo, it requires some maven-archetype-plugin (1.0-alpha-4)
# It doesn't work with version 2.2
rm src/main/java/org/jenkinsci/maven/plugins/hpi/CreateMojo.java

%build
%mvn_build

%install
%mvn_install


%files -f .mfiles
%dir %{_javadir}/%{name}
%doc LICENSE-ASL LICENSE-MIT
%files javadoc -f .mfiles-javadoc
%doc LICENSE-ASL LICENSE-MIT


%changelog
* Wed Feb 04 2015 Michal Srb <msrb@redhat.com> - 1.112-1
- Update to upstream version 1.112

* Tue Nov 18 2014 Michal Srb <msrb@redhat.com> - 1.109-2
- Correctly identify core plugins

* Mon Jun 16 2014 Michal Srb <msrb@redhat.com> - 1.109-1
- Update to upstream version 1.109

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.108-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Wed May 07 2014 Michal Srb <msrb@redhat.com> - 1.108-1
- Update to upstream version 1.108

* Wed Nov 06 2013 Michal Srb <msrb@redhat.com> - 1.106-1
- Update to upstream version 1.106

* Wed Oct 30 2013 Michal Srb <msrb@redhat.com> - 1.100-1
- Update to upstream version 1.100

* Fri Sep 27 2013 Michal Srb <msrb@redhat.com> - 1.99-1
- Update to upstream version 1.99

* Mon Sep 02 2013 Michal Srb <msrb@redhat.com> - 1.98-2
- Add BR: ant-apache-regexp

* Mon Sep 02 2013 Michal Srb <msrb@redhat.com> - 1.98-1
- Update to upstream version 1.98

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.96-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Mon Jun 24 2013 Michal Srb <msrb@redhat.com> - 1.96-1
- Update to upstream version 1.96
- Fix directory ownership

* Mon May 06 2013 Michal Srb <msrb@redhat.com> - 1.95-1
- Initial package

